unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, ComCtrls, ExtCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, StdCtrls, TAGraph, TASeries, TASources, TATools,
  TATransformations, TACustomSeries, TAIntervalSources, TAChartLiveView;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ChartLiveView1: TChartLiveView;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    catOscillatorLinearAxisTransform1: TLinearAxisTransform;
    catOscillator: TChartAxisTransformations;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointDragTool1: TDataPointDragTool;
    ChartToolset1PanDragTool1: TPanDragTool;
    ChartToolset1ZoomDragTool1: TZoomDragTool;
    chOscillator: TChart;
    chOscillatorLineSeries1: TLineSeries;
    lcsOscillator: TListChartSource;
    PageControl1: TPageControl;
    Panel1: TPanel;
    RandomChartSource1: TRandomChartSource;
    tsOscilloscope: TTabSheet;
    tsOwnerDrawnPointer: TTabSheet;
    timOscilloscope: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure timOscilloscopeTimer(Sender: TObject);
  private
    FStartTime: TDateTime;
    procedure StartMeasurement;
  end;

var
  Form1: TForm1; 

implementation

{$R *.lfm}

uses
  LCLIntf, IntfGraphics, TAChartUtils, TAChartAxisUtils;

const
  BESCHLEUNIGUNG = 200;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  DateTimeIntervalChartSource1.DateTimeFormat := 'hh:mm';
  with chOscillator.BottomAxis do begin
    Grid.Style := psSolid;   // das fest stehende Punktmuster beim durchlaufenden Chart irritiert mich...
    Grid.Color := $333333;
    Marks.Source := DateTimeIntervalChartSource1;
    Marks.Style := smsLabel;
    Title.Caption := 'Zeit (Std)';
//    Range.Min:=0;              // Das verträgt sich nicht mit der Live-View
//    Range.Max:=0.1;
//    Range.UseMin:=True;
//    Range.UseMax:=True;
  end;
  with chOscillator.LeftAxis do
  begin
    Grid.Style := psSolid;
    Grid.Color := $333333;
    Range.Min := -1;
    Range.Max := +1;
    Range.UseMin := true;
    Range.UseMax := true;
    Title.Caption := 'y';
    Title.Visible := true;
  end;

  // Je nach Länge der letzten Datenbeschriftung springt der rechte Rand des Chart
  // an eine andere Stelle, was etwas nervig ist. Um das zu verhindern, eine
  // rechte Achse einbauen und für diese etwas Platz reservieren.
  with chOscillator.AxisList.Add do
  begin
    Alignment := calRight;
    Title.Caption := ' ';     // Ohne Title funktioniert diese Trick nicht...
    Title.Visible := true;
    Marks.Visible := false;
    LabelSize := 20;
  end;

  // chOscillator.MarginsExternal.Right := 30;  // das hat nicht denselben Effekt...

  with ChartLiveView1 do
  begin
    Chart := chOscillator;
    ViewportSize := 1.0/24; // Das sichtbare Fenster soll 1/24 Tag = 1 Std umfassen.
    Active := true;
    ExtentY := lveLogical;  // y Achse auf den oben festgelegten Bereich einschränken. Das macht die Darstellung ruhiger.
  end;

  StartMeasurement;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ChartLiveView1.Active := not ChartLiveView1.Active;
  if ChartLiveView1.Active then
    Button1.Caption := 'Scrollen anhalten'
  else
    Button1.Caption := 'Weiterscrollen';
end;

procedure TForm1.StartMeasurement;
begin
  timOscilloscope.Interval := 10;  // mehr Zwischenwerte wegen der "Beschleunigung". Kann später wieder entfallen.
  timOscilloscope.Enabled := PageControl1.ActivePage = tsOscilloscope;
  FStartTime := Now;
end;

procedure TForm1.timOscilloscopeTimer(Sender: TObject);
var
  t: TDateTime;
begin
  t := (Now - FStartTime) * BESCHLEUNIGUNG;  // BESCHLEUNIGUNG als Zeitraffer damit ich nicht den ganzen Tag warten muss. Muss später wieder weg.
  with chOscillatorLineSeries1 do
    AddXY(t, sin(t*2*pi*48));    // 48 --> pro Stunde 2 Schwingungen
end;

end.

